taekonline/urls.py
from django.contrib import admin
from django.urls import path
from taekonline import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home'),
    path('student', views.student, name='student'),
    path('student/<int:id>/change', views.student_change, name='student_change'),
    path('student/add', views.student_add, name='student_add'),
    path('student/<int:id>/deactivate', views.student_change, name='student_deactivate'),
    path('student/<int:id>/ativate', views.student_change, name='student_activate'),
    path('student/<int:id>/rank_history', views.rank_history, name='rank_history'),
    path('belt_exam', views.belt_exam, name='belt_exam'),
    path('attendance', views.attendance, name='attendance'),
    path('attendance/<int:id>/delete', views.attendance_delete, name='attendance_delete'),
    path('income', views.income, name='income'),
    path('income/add', views.income_add, name='income_add'),
    path('incomeproduct', views.incomeproduct, name='incomeproduct'),

    #path('/studentcontact/<int:id>/delete', views.studentcontact_delete, name='studentcontact_delete'),

    #path('student/add'), views.student_add, name='student_add'),
    path('product', views.product, name='product'),
    path('product/add', views.product_add, name='product_add'),
    path('product/<int:id>/delete', views.product_delete, name='product_delete'),
    path('product/<int:id>/change', views.product_change, name='product_change'),
    path('about_us', views.about_us, name='about_us'),
    path('project', views.project, name='project'),

]

taekonline/models.py
from django.db import models, connections
import datetime
from django.utils import timezone
import pytz
from django.contrib.auth.models import User
from django.core.validators import MaxValueValidator, MinValueValidator
from decimal import Decimal
from phonenumber_field.modelfields import PhoneNumberField

      
class Student(models.Model):
    first_name = models.CharField(max_length=100, null=False, blank=False)
    last_name = models.CharField(max_length=100, null=False, blank=False)
    date_of_birth = models.DateField(auto_now=False, auto_now_add=False)
    date_joined = models.DateTimeField(auto_now=False, auto_now_add=True)
    phone_number = PhoneNumberField()
    email = models.EmailField(blank=False, null=False)
    address_number = models.IntegerField(verbose_name="number", null=False, blank=False)
    address_street = models.CharField(verbose_name="street", max_length=200, null=False, blank=False)
    address_complement = models.CharField(max_length=200, null=True, blank=True)
    address_zip_code = models.CharField(max_length=6, null=False, blank=False)
    address_city = models.CharField(max_length=50, null=False, blank=False)
    active = models.BooleanField(default=True)
    
    @property
    def name(self):
        return ', '.join((self.first_name,self.last_name))

    @property
    def rank(self):
        if self.rankhistory_set.count() > 0:
            return self.rankhistory_set.all().order_by('-rank__order')[0].rank.description
        return None

    def __str__(self):
        return self.name


class ContactType(models.Model):
    description = models.CharField(max_length=100, null=False, blank=False)

    def __str__(self):
        return self.description


class StudentContact(models.Model):
    student = models.ForeignKey(to=Student, null=False, blank=False, on_delete=models.CASCADE, related_name='student')
    contact_type = models.ForeignKey(to=ContactType, null=False, blank=True, on_delete=models.PROTECT)
    #order = models.IntegerField(null=False, blank=False, default=0)
    contact = models.ForeignKey(to=Student, null=True, blank=True, on_delete=models.CASCADE, related_name='contact')
    first_name = models.CharField(max_length=100, null=True, blank=True)
    last_name = models.CharField(max_length=100, null=True, blank=True)
    phone_number = PhoneNumberField(blank=True)
    email = models.EmailField(blank=True, null=True)

    def __str__(self):
        if self.contact:
            return self.contact.__str__()
        else:
            return ', '.join((self.first_name,self.last_name))

class Rank(models.Model):
    description = models.CharField(max_length=100, null=False, blank=False)
    order = models.IntegerField(null=False, blank=False, unique=True)

    def __str__(self):
        return self.description

class RankHistory(models.Model):
    rank = models.ForeignKey(Rank, null=False, blank=False, on_delete=models.PROTECT)
    student = models.ForeignKey(Student, null=False, blank=False, on_delete=models.PROTECT)
    exam_date = models.DateTimeField(null=False, blank=False)


class ClassCathegory(models.Model):
    description = models.CharField(max_length=100, null=False, blank=False)
    color = models.CharField(max_length=100, null=False, blank=False)

    def __str__(self):
        return self.description


class ClassAgenda(models.Model):
    cathegory = models.ForeignKey(ClassCathegory, null=True, blank=True, on_delete=models.SET_NULL)
    start_time = models.TimeField()
    end_time = models.TimeField()
    sunday = models.BooleanField(default=False)
    monday = models.BooleanField(default=False)
    tuesday = models.BooleanField(default=False)
    wednesday = models.BooleanField(default=False)
    thursday = models.BooleanField(default=False)
    friday = models.BooleanField(default=False)
    saturday = models.BooleanField(default=False)


class Attendance(models.Model):
    student = models.ForeignKey(Student, null=False, blank=False, on_delete=models.PROTECT)
    class_date = models.DateTimeField(null=False, blank=False)


class Product(models.Model):
    name = models.CharField(max_length=100, null=False, blank=False, unique=True)
    description = models.CharField(max_length=200, null=False, blank=False)
    cost_price = models.DecimalField(null=False, blank=False, max_digits=18, decimal_places=2, default=0)
    selling_price = models.DecimalField(null=False, blank=False, max_digits=18, decimal_places=2)
    quantity = models.IntegerField(null=False, blank=False, default=1)
    keep_inventory = models.BooleanField(default=True)

    def __str__(self):
        return self.name

class Income(models.Model):
    income_date = models.DateField(null=False, blank=False)
    income_time = models.TimeField(null=False, blank=False)
    student = models.ForeignKey(Student, null=True, blank=True, on_delete=models.CASCADE)

    @property
    def income_datetime(self):
        if self.income_date and self.income_time:
            return ' '.join((self.income_date.strftime("%Y-%m-%d"), self.income_time.strftime("%H:%M")))
        return None

    @property
    def products(self):
        if self.incomeproduct_set.all().count() > 0:
            products_str=''
            for p in self.incomeproduct_set.all():
                products_str = ''.join((products_str, p.product.name, ','))
            return products_str
        return None
    

class IncomeProduct(models.Model):
    income = models.ForeignKey(Income, null=False, blank=False, on_delete=models.CASCADE)
    product = models.ForeignKey(Product, null=False, blank=False, on_delete=models.CASCADE)
    quantity = models.IntegerField(null=False, blank=False, default=1)
    profit = models.DecimalField(null=True, blank=True, max_digits=18, decimal_places=2)

    def __str__(self):
        return ' '.join((str(self.income.id), self.product.name))

    def save(self, *args, **kwargs):
        if not self.id:
            self.profit = self.quantity * (self.product.selling_price - self.product.cost_price)
        #super(Model, self).save(*args, **kwargs)
        super().save(*args, **kwargs)

taekonline/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.contrib.auth import login as auth_login, authenticate
from django.contrib.auth import logout as auth_logout
from django.contrib import messages
from django.db.models import Count, F
from django.utils import timezone
from django.http import JsonResponse
from taekonline.models import Student, RankHistory, Attendance, Income, Product, IncomeProduct
from taekonline.tables import StudentTable, BeltExamTable, AttendanceTable, IncomeTable, \
	IncomeProductTable, ProductTable
from taekonline.forms import StudentForm, StudentContactForm, StudentContactFormSet, \
	IncomeForm, IncomeProductFormSet, ProductForm
from django.forms import formset_factory, inlineformset_factory
from taekonline.business import StudentBusiness
import datetime
from django.db import transaction
from django_tables2 import RequestConfig
from taekonline.filters import IncomeProductFilter



def home(request):
	return render(request, 'home.html')

def profile(request):
	return render(request, 'profile.html')

def student(request, template_name='students/student_list.html'):

	students_table = StudentTable(Student.objects.all())
	return render(request, template_name, {'students_table':students_table })

@transaction.atomic
def student_add(request, template_name='students/student_form.html'):
	if request.POST:
		form = StudentForm(request.POST)
		formset = StudentContactFormSet(request.POST, request.FILES, instance=form.instance)
		if form.is_valid() and formset.is_valid():
			form.save()
			formset.save()
			return redirect('student')
		else:
			return render(request, template_name, {'form':form, 'formset':formset})
	else:
		form = StudentForm()
		formset = StudentContactFormSet()
	return render(request, template_name, {'form':form, 'formset':formset})

@transaction.atomic
def student_change(request, id, template_name='students/student_form.html'):
	student = Student.objects.get(id=int(id))
	if request.POST:
		form = StudentForm(request.POST, instance=student)
		formset = StudentContactFormSet(request.POST, request.FILES, instance=student)

		if form.is_valid() and formset.is_valid():
			form.save()
			formset.save()
			return redirect('student')
		else:
			return render(request, template_name, {'form':form, 'formset':formset})
	else:
		form = StudentForm(instance=student)
		formset = StudentContactFormSet(instance=student)
	return render(request, template_name, {'form':form, 'formset':formset})

def rank_history(request, id, template_name='students/student_rank_history.html'):
	student = Student.objects.get(id=int(id))
	rank_history = list(RankHistory.objects.filter(student__id=int(id)).values('rank__description', 'exam_date').order_by('exam_date'))
	attendance = Attendance.objects.filter(student__id=int(id)).order_by('class_date').values()

	att_count = attendance.count()
	rh_count = len(rank_history)

	'''
	if rank_history_count == 0 or attendance_count == 0:
		return render(request, template_name, {'student': student, 'rank_history': rank_history})	
	'''

	for rh in rank_history:
		rh['attendances'] = []

	att_index = 0
	rh_index = 0
	while att_index < (att_count - 1):
		att = attendance[att_index]
		rh = rank_history[rh_index]
		if rh_index == rh_count - 1:
			rh['attendances'].append({ 'class_date': att['class_date'], 'id':att['id'] })
			att_index = att_index + 1
		elif att['class_date'] >= rh['exam_date'] and att['class_date'] < rank_history[rh_index+1]['exam_date']:
			rh['attendances'].append({ 'class_date': att['class_date'], 'id':att['id'] })
			att_index = att_index + 1
		elif att['class_date'] < rh['exam_date'] and rh_index == 0:
			rh['attendances'].append({ 'class_date': att['class_date'], 'id':att['id'] })
			att_index = att_index + 1
		else:
			rh_index = rh_index + 1
		
	
	return render(request, template_name, {'student': student, 'rank_history': rank_history})

def student_activate(request, id):
	pass

def student_deactivate(request, id):
	pass

def belt_exam(request, template_name='students/belt_exam.html'):
	students_table = BeltExamTable(Student.objects.filter(active=True))
	if request.POST:
		exam_date = request.POST.get('exam_date')
		exam_time = request.POST.get('exam_time')
		datetime_str = exam_date + ' ' + exam_time
		exam_datetime = datetime.datetime.strptime(datetime_str, '%Y-%m-%d %H:%M')

		# Get the list and transform in a list of integers
		selected_student = list(map(int, request.POST.getlist('selected_student')))
		sb = StudentBusiness()
		for sid in selected_student:
			sb.increase_rank(request=request, student_id=sid, exam_date=exam_datetime)

	return render(request, template_name, {'students_table':students_table })

@transaction.atomic
def attendance(request, template_name='students/attendance.html'):
	students_table = AttendanceTable(Student.objects.filter(active=True))
	if request.POST:
		class_date = request.POST.get('class_date')
		class_time = request.POST.get('class_time')
		datetime_str = class_date + ' ' + class_time
		class_datetime = datetime.datetime.strptime(datetime_str, '%Y-%m-%d %H:%M')

		# Get the list and transform in a list of integers
		selected_student = list(map(int, request.POST.getlist('selected_student')))
		students = Student.objects.filter(id__in=selected_student)
		for student in students:
			attendance = Attendance()
			attendance.student=student
			attendance.class_date=class_datetime
			attendance.save()

		msg = 'Atterndance for {dt} registred sucessfully.'.format(dt=datetime_str)
		messages.success(request, msg)

	return render(request, template_name, {'students_table':students_table })

def attendance_delete(request, id, template_name='students/student_rank_history.html'):
	attendance = Attendance.objects.get(id=int(id))
	student_id = attendance.student.id
	attendance.delete()
	return redirect('rank_history', id=student_id)


def product(request,template_name='products/product_list.html'):
	products_table = ProductTable(Product.objects.all())
	return render(request, template_name, {'products_table':products_table })
	#return render(request, "products/product_list.html")

def product_add(request, template_name='products/product_form.html'):
	if request.POST:
		form = ProductForm(request.POST)
		
		if form.is_valid():
			form.save()
			return redirect('product')
		else:
			return render(request, template_name, {'form':form})
	else:
		form = ProductForm()
	return render(request, template_name, {'form':form})

def product_delete(request, id):
	Product.objects.get(id=int(id)).delete()
	
	return redirect('product')

#@transaction.atomic
def product_change(request, id, template_name='products/product_form.html'):
	product = Product.objects.get(id=int(id))
	if request.POST:
		form = ProductForm(request.POST, instance=product)
		#formset = ProductForm(request.POST, request.FILES, instance=product)

		#if form.is_valid() and formset.is_valid():
		if form.is_valid():
			form.save()
			#formset.save()
			return redirect('product')
		else:
			#return render(request, template_name, {'form':form, 'formset':formset})
			return render(request, template_name, {'form':form})
	else:
		form = ProductForm(instance=product)
		#formset = ProductForm(instance=product)
	#return render(request, template_name, {'form':form, 'formset':formset})
	return render(request, template_name, {'form':form})

def about_us(request):
	return render(request, "about_us.html")

def project(request):
	return render(request, "project.html")	

def income(request, template_name='income/income_list.html'):

	income_table = IncomeTable(Income.objects.all())
	return render(request, template_name, {'income_table':income_table })

@transaction.atomic
def income_add(request, template_name='income/income_form.html'):
	if request.POST:
		form = IncomeForm(request.POST)
		formset = IncomeProductFormSet(request.POST, request.FILES, instance=form.instance, prefix='products')
		if formset.is_valid():
			for f in formset:
					cd = f.cleaned_data
					f_product = cd.get('product')
					f_quantity = cd.get('quantity')
					if f_product.keep_inventory:
						if f_product.quantity > int(f_quantity):
							f_product.quantity = f_product.quantity - int(f_quantity)
							f_product.save()
						else:
							f.add_error('quantity', 'Quantity is greater than the quantity in inventory')
		if form.is_valid() and formset.is_valid():
			form.save()
			formset.save()
			return redirect('income')
		else:
			return render(request, template_name, {'form':form, 'formset':formset})
	else:
		form = IncomeForm()
		#formset = IncomeProductFormSet()
		formset = IncomeProductFormSet(prefix='products')
	return render(request, template_name, {'form':form, 'formset':formset})


def incomeproduct(request, template_name='incomeproduct/incomeproduct_list.html'):

	
	queryset = IncomeProduct.objects.all()
	f = IncomeProductFilter(request.GET, queryset=queryset)
	table = IncomeProductTable(f.qs)

	RequestConfig(request).configure(table)
	return render(request, template_name, {'table':table, 'filter':f })

taekonline/templates/students/attendance.html
{% extends 'base.html' %}
{% load render_table from django_tables2 %}
{% load static %}

{% block extrahead %}
<script>
$(document).ready(function() {
    $('#student_table').DataTable();
} );
$(document).ready(function() {

    var date = new Date();

    if (!$("#id_class_date").val()) {
        var day = date.getDate();
        var month = date.getMonth() + 1;
        var year = date.getFullYear();

        if (month < 10) month = "0" + month;
        if (day < 10) day = "0" + day;

        var today = year + "-" + month + "-" + day;       
        $("#id_class_date").attr("value", today);
    }

    if (!$("#id_class_time").val()) {
        var hour = date.getHours();
        var minutes = date.getMinutes();
        if(hour < 10) hour = '0' + hour; 
        if(minutes < 10) minutes = '0' + minutes; 
        var now = hour + ":" + minutes;
        $("#id_class_time").attr("value", now);
    }
});
</script>
{% endblock extrahead %}


{% block content %}
<nav class="navbar navbar-dark bg-primary" style="margin-top: 25px;margin-bottom: 25px;">
    <a class="navbar-brand" href="#">Attendance List</a>
</nav>

<form method="POST" action="{% url 'attendance' %}">
    {% csrf_token %}
    <div class="row form-group">
        <div class="col-md-6">
            <label for="id_class_date">Class Date:</label>
            <input type="date" id="id_class_date" name="class_date" required>
        </div>
        <div class="col-md-6">
            <label for="id_class_time">Class Time:</label>
            <input type="time" id="id_class_time" name="class_time" required>
        </div>
    </div>
    {% render_table students_table %}
    <button type="submit" class="btn btn-primary">Present</button>
</form>

{% endblock content %}

taekonline/templates/students/belt_exam.html
{% extends 'base.html' %}
{% load render_table from django_tables2 %}
{% load static %}

{% block extrahead %}
<script>
$(document).ready(function() {
    $('#student_table').DataTable();
} );
$(document).ready(function() {

    var date = new Date();

    if (!$("#id_exam_date").val()) {
        var day = date.getDate();
        var month = date.getMonth() + 1;
        var year = date.getFullYear();

        if (month < 10) month = "0" + month;
        if (day < 10) day = "0" + day;

        var today = year + "-" + month + "-" + day;       
        $("#id_exam_date").attr("value", today);
    }

    if (!$("#id_exam_time").val()) {
        var hour = date.getHours();
        var minutes = date.getMinutes();
        if(hour < 10) hour = '0' + hour; 
        if(minutes < 10) minutes = '0' + minutes; 
        var now = hour + ":" + minutes;
        $("#id_exam_time").attr("value", now);
    }
});
</script>
{% endblock extrahead %}


{% block content %}
<nav class="navbar navbar-dark bg-primary" style="margin-top: 25px;margin-bottom: 25px;">
    <a class="navbar-brand" href="#">Belt Exam</a>
</nav>

<form method="POST" action="{% url 'belt_exam' %}">
    {% csrf_token %}
    <div class="row form-group">
        <div class="col-md-6">
            <label for="id_exam_date">Exam Date:</label>
            <input type="date" id="id_exam_date" name="exam_date" required>
        </div>
        <div class="col-md-6">
            <label for="id_exam_time">Exam Date:</label>
            <input type="time" id="id_exam_time" name="exam_time" required>
        </div>
    </div>
    {% render_table students_table %}
    <button type="submit" class="btn btn-primary">Increase Belt</button>
</form>

{% endblock content %}

taekonline/templates/students/car_confirm_delete.html
{% extends 'base.html' %}
{% load static %}
{% block content %}
<h1>Car Delete</h1>
<form method="post">{% csrf_token %}
    Are you sure you want to delete "{{ object }}" ?
    <input type="submit" class="btn btn-primary" value="Submit" />
</form>
{% endblock content %}

taekonline/templates/students/car_detail.html
{% extends 'base.html' %}
{% load static %}
{% block content %}
<h1>Car Details</h1>
<h2>Owner: {{object.owner}}</h2>
Plate: {{ object.plate }}
{% endblock content %}

taekonline/templates/students/student_form.html
{% extends 'base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block extrahead %}
    {{bloc.super}}
    
    <script type="text/javascript">
        $( document ).ready(function() {

            if (! $("#id_student-0-contact_type").val()) {
                $("#id_student-0-contact").prop('disabled', true);
                $("#id_student-0-first_name").prop('disabled', true);
                $("#id_student-0-last_name").prop('disabled', true);
                $("#id_student-0-phone_number").prop('disabled', true);
                $("#id_student-0-email").prop('disabled', true);
            }

            if (! $("#id_student-1-contact_type").val()) {
                $("#id_student-1-contact").prop('disabled', true);
                $("#id_student-1-first_name").prop('disabled', true);
                $("#id_student-1-last_name").prop('disabled', true);
                $("#id_student-1-phone_number").prop('disabled', true);
                $("#id_student-1-email").prop('disabled', true);
            }

            if ($("#id_student-0-contact").val()) {
                $("#id_student-0-first_name").prop('disabled', true);
                $("#id_student-0-last_name").prop('disabled', true);
                $("#id_student-0-phone_number").prop('disabled', true);
                $("#id_student-0-email").prop('disabled', true);
            }

            if ($("#id_student-1-contact").val()) {
                $("#id_student-1-first_name").prop('disabled', true);
                $("#id_student-1-last_name").prop('disabled', true);
                $("#id_student-1-phone_number").prop('disabled', true);
                $("#id_student-1-email").prop('disabled', true);
            }

            $("#id_student-0-contact_type").on('change', function() {
                if (this.value) {
                    // Enable all
                    $("#id_student-0-contact").prop('disabled', false);
                    $("#id_student-0-first_name").prop('disabled', false);
                    $("#id_student-0-last_name").prop('disabled', false);
                    $("#id_student-0-phone_number").prop('disabled', false);
                    $("#id_student-0-email").prop('disabled', false);
                } else {
                    // Clear all
                    $("#id_student-0-contact").val("");
                    $("#id_student-0-first_name").val("");
                    $("#id_student-0-last_name").val("");
                    $("#id_student-0-phone_number").val("");
                    $("#id_student-0-email").val("");
                    // Disable all
                    $("#id_student-0-contact").prop('disabled', true);
                    $("#id_student-0-first_name").prop('disabled', true);
                    $("#id_student-0-last_name").prop('disabled', true);
                    $("#id_student-0-phone_number").prop('disabled', true);
                    $("#id_student-0-email").prop('disabled', true);
                }
            });

            $("#id_student-1-contact_type").on('change', function() {
                if (this.value) {
                    // Enable all
                    $("#id_student-1-contact").prop('disabled', false);
                    $("#id_student-1-first_name").prop('disabled', false);
                    $("#id_student-1-last_name").prop('disabled', false);
                    $("#id_student-1-phone_number").prop('disabled', false);
                    $("#id_student-1-email").prop('disabled', false);
                } else {
                    // Clear all
                    $("#id_student-1-contact").val("");
                    $("#id_student-1-first_name").val("");
                    $("#id_student-1-last_name").val("");
                    $("#id_student-1-phone_number").val("");
                    $("#id_student-1-email").val("");

                    // Disable all
                    $("#id_student-1-contact").prop('disabled', true);
                    $("#id_student-1-first_name").prop('disabled', true);
                    $("#id_student-1-last_name").prop('disabled', true);
                    $("#id_student-1-phone_number").prop('disabled', true);
                    $("#id_student-1-email").prop('disabled', true);
                }
            });



            $("#id_student-0-contact").on('change', function() {
                if (this.value) {
                    $("#id_student-0-first_name").val("");
                    $("#id_student-0-last_name").val("");
                    $("#id_student-0-phone_number").val("");
                    $("#id_student-0-email").val("");
                    $("#id_student-0-first_name").prop('disabled', true);
                    $("#id_student-0-last_name").prop('disabled', true);
                    $("#id_student-0-phone_number").prop('disabled', true);
                    $("#id_student-0-email").prop('disabled', true);
                } else {
                    $("#id_student-0-first_name").prop('disabled', false);
                    $("#id_student-0-last_name").prop('disabled', false);
                    $("#id_student-0-phone_number").prop('disabled', false);
                    $("#id_student-0-email").prop('disabled', false);
                }
            });

            $("#id_student-1-contact").on('change', function() {
                if (this.value) {
                    $("#id_student-1-first_name").val("");
                    $("#id_student-1-last_name").val("");
                    $("#id_student-1-phone_number").val("");
                    $("#id_student-1-email").val("");
                    $("#id_student-1-first_name").prop('disabled', true);
                    $("#id_student-1-last_name").prop('disabled', true);
                    $("#id_student-1-phone_number").prop('disabled', true);
                    $("#id_student-1-email").prop('disabled', true);
                } else {
                    $("#id_student-1-first_name").prop('disabled', false);
                    $("#id_student-1-last_name").prop('disabled', false);
                    $("#id_student-1-phone_number").prop('disabled', false);
                    $("#id_student-1-email").prop('disabled', false);
                }
            });

        });
        
    </script>
    
{% endblock extrahead %}

{% block messages %}
    {{bloc.super}}
    {% for message in form.errors %}
        <div class="alert alert-danger alert-dismissible fade show" role="alert">
            {{ message|safe }}
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    {% endfor %}
    {% for message in formset.errors %}
    <div class="alert alert-danger alert-dismissible fade show" role="alert">
        {{ message|safe }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    {% endfor %}

{% endblock messages %}


{% block content %}
<form method="post" action="{{ request.path }}">
    <h1>Student</h1>
    {% crispy form %} 
    <h1>Contacts</h1>
    {{ formset.management_form|crispy }}
    <table class="table table-striped table-condensed">
        {% for f in formset.forms %}
        <tr class="{% cycle 'contact1' 'contact2' %}">
            {% crispy f %}
            {% if f.fields.id.initial and formset.can_delete %}
                {{ f.DELETE }} <label>{{ f.DELETE.label }}</label>
            {% endif %}
        </tr>
        <hr>
        {% endfor %}
    </table>

    <input type="submit" class="btn btn-primary" value="Save">
    
</form>

<!--
<script src="//ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="{% static 'formset/jquery.formset.js' %}"></script>
<script type="text/javascript">
    $('.formset_row').formset({
        addText: 'add contact',
        deleteText: 'remove',
        prefix: 'familymember_set'
    });
</script>
-->
{% endblock content %}

taekonline/templates/students/student_list.html
{% extends 'base.html' %}
{% load render_table from django_tables2 %}
{% load static %}

{% block extrahead %}
<script>
$(document).ready(function() {
    $('#student_table').DataTable();
} );
</script>
{% endblock extrahead %}


{% block content %}
<nav class="navbar navbar-dark bg-primary" style="margin-top: 25px;margin-bottom: 25px;">
    <a class="navbar-brand" href="#">Students</a>
</nav>

{% render_table students_table %}

<div class="row">
    <div class="col-md-2">
        <a class="btn btn-primary"  href="{% url 'student_add' %}">Add</a>
    </div>
</div>


{% endblock content %}

taekonline/templates/students/student_rank_history.html
{% extends 'base.html' %}
{% load render_table from django_tables2 %}
{% load static %}

{% block extrahead %}
<script>
$(document).ready(function() {
    $('#rank_hitory').DataTable();
    $('#attendance').DataTable();
} );
</script>
{% endblock extrahead %}


{% block content %}
<nav class="navbar navbar-dark bg-primary" style="margin-top: 25px;margin-bottom: 25px;">
    <a class="navbar-brand" href="#">Rank History - {{student.name}}</a>
</nav>
{% for rh in rank_history %}
    {% cycle '1' '2' '3' as row silent %}
    {% if row == '1' %}
        <div class="row" style="margin-top: 15px;">
    {% endif %}
        <div class="col-md-4">
            <div class="card">
                {% if rh.rank__description|lower in 'white,none' %}
                    <div class="card-header bg-light">Exam Date: {{rh.exam_date|date:'Y-m-d H:i'}}</div>
                {% elif rh.rank__description|lower in 'yellow' %}
                    <div class="card-header bg-warning">Exam Date: {{rh.exam_date|date:'Y-m-d H:i'}}</div>
                {% else %}
                    <div class="card-header" style="background-color:{{rh.rank__description|lower}};">Exam Date: {{rh.exam_date|date:'Y-m-d H:i'}}</div>
                {% endif %}
                <div class="card-body">
                    {% for att in rh.attendances %}
                        <li class="list-group-item">
                            {{att.class_date|date:'Y-m-d H:i'}}
                            <div class="float-right">
                            <a href="{% url 'attendance_delete' id=att.id %}"><i class="fas fa-trash-alt"></i></a>
                            </div>
                        </li>
                    {% endfor %}
                </div>
                <div class="card-footer">Attendance: {{ rh.attendances|length }}</div>
            </div>
        </div>
    {% if row == '3' or forloop.last %}
        </div>
    {% endif %}
{% endfor %}

{% endblock content %}